program Vesa_Virtual_Scrolling_Test;
{$G+,N+,E-}
uses Graph, Crt;

var
  GraphDriver, GraphMode, XX, YY: Integer;
  Result: Integer;
  Ch: Char;
  FNum: Byte;
  TmpStr, PostFix: string;

procedure GetStart(var Res: Integer; var X: Integer; var Y: Integer); assembler;
asm
	mov ax, $4F07
	xor bx, bx
	mov bl, 1
	int $10
	les di, Res
	mov word ptr es:[di], ax
	les di, X
	mov word ptr es:[di], cx
	les di, Y
	mov word ptr es:[di], dx
end;

procedure SetStart(var Res: Integer; X: Integer; Y: Integer); assembler;
asm
	mov ax, $4F07
	xor bx, bx
	mov bl, byte ptr [FNum]
	mov cx, word ptr [X]
	mov dx, word ptr [Y]
	int $10
	les di, Res
	mov word ptr es:[di], ax
end;

begin
  FNum := 0;
  GraphDriver := InstallUserDriver('svga386', nil);
  GraphMode := 40;
  InitGraph(GraphDriver, GraphMode, '');
  SetFillStyle(1, Yellow);
  Bar(280, 200, 360, 280);
  SetTextStyle(2, HorizDir, 4);

  SetColor(white);
  OutTextXY(10, 40, 'Press arrow keys to test GetStart/SetStart.' +
    ' Press Space to change between 00h/80h tests. Press Esc to Exit.');

  repeat
    Ch := Chr(0);
    Ch := ReadKey;
    if (Ch = Chr(32)) or (Ch = Chr(72)) or (Ch = Chr(80)) or (Ch = Chr(75)) or (Ch = Chr(77)) then
    begin
      SetFillStyle(1, 0);
      Bar(10, 80, 320, 160);

      SetColor(white);

      GetStart(Result, XX, YY);

      if Lo(Result) = $4F then
        TmpStr := 'Supported'
      else
        TmpStr := 'Not Supported';
      outtextxy(10, 80, 'GetStart is ' + TmpStr);
      if Hi(Result) = 0 then
        TmpStr := 'call Successful'
      else
        TmpStr := 'call Failed';
      outtextxy(10, 100, 'GetStart ' + TmpStr);

      if Ch = Chr(32) then
        FNum := FNum xor $80
      else if Ch = Chr(72) then
        YY := YY + 1
      else if Ch = Chr(80) then
        YY := YY - 1
      else if Ch = Chr(75) then
        XX := XX + 1
      else if Ch = Chr(77) then
        XX := XX - 1;
      if XX < 0 then XX := 639;

      SetStart(Result, XX, YY);

      if FNum = 0 then
        PostFix := ' (00h)'
      else
        PostFix := ' (80h)';
      if Lo(Result) = $4F then
        TmpStr := 'Supported'
      else
        TmpStr := 'Not Supported';
      outtextxy(10, 120, 'SetStart is ' + TmpStr + PostFix);
      if Hi(Result) = 0 then
        TmpStr := 'call Successful'
      else
        TmpStr := 'call Failed';
      outtextxy(10, 140, 'SetStart ' + TmpStr + PostFix);
    end;
  until Ch = Chr(27);

  CloseGraph;
end.

